Subject: RE: [nemo] Re: [manet] NEMO or MANET?

From: Lawrence MacIntyre <[email-masked]>
Date: Wed, 08 Oct 2003 10:02:52 -0400

I'm not sure I understand your comment (or was it a question?).  If you
have a reason to communicate with a node, you need to know its address. 
In the case of a non-routing node behind a MANET router, it would
ideally share the network address of that router, just as nodes behind a
standard IP router share the network address of their router.  MANETs
are just like infrastructured networks in that respect.  The only
difference is that the interconnectivity is not fixed.  The routing
protocol is designed to discover and utilize connectivity.  To
communicate with a node, you must have a way to learn its address, but
that is not part of the routing protocol.

On Wed, 2003-10-08 at 08:38, Pascal Thubert (pthubert) wrote:
> Hi Lawrence:
> 
> I guess the question was not about the car address, but the prefix
> behind it. Like a MANET router with a bunch of non manet enabled nodes
> attached to it. 
> 
> One way of seeing this is a lookup that resolved the "dumb" node prefix
> into a via manet router (this is a constant) and then resolves where the
> manet router is (say using a flooding). Another is to flood directly to
> the "dumb" node address but then the manet router has to terminate the
> protocol and respond itself.
> 
> This is all the difference between MIP and Nemo, actually. I may be
> missing something but I'm not sure this is fully addressed in MANET
> either?
> 
> Pascal 
> 
> > -----Original Message-----
> > From: Lawrence MacIntyre [mailto:[email-masked]]
> > Sent: mercredi 8 octobre 2003 14:11
> > To: Wanrong Yu
> > Cc: [email-masked]; [email-masked]
> > Subject: [nemo] Re: [manet] NEMO or MANET?
> > 
> > For MANET, this is no problem at all.  The Mobile Routers (cars) will
> > discover each other and communicate directly.  There is no need for
> any
> > fixed infrastructure.
> > 
> > On Wed, 2003-10-08 at 05:25, Wanrong Yu wrote:
> > > Hi,all
> > >   I have read some drafts of NEMO and MANET, but I
> > > have some doubts. If there are several mobile networks,
> > > each has one or more MRs(we can imagine several cars),
> > > these cars meet and want to communication with each
> > > other, if the fixed infrastructure is unsable for some
> > > reasons, does the communication possible? and how?
> > >   From the aspect of NEMO, we can loose the restrict
> > > of the existence of fixed infrastructure, from the
> > > aspect of MANET, we can extend the single node in the
> > > ad hoc to a subnet, both will point to the scenario
> > > above. I think this maybe a new scenario neithor NEMO
> > > or MANET has covered, and there are new issues arise
> > > such as routing and security.
> > >    Does there any researchs on this scenario, or some
> > > current technology have solve the problem perfectly?
> > >    Any comments or advices are welcomed, thanks a lot!
> > >
> > >  Wanrong Yu
> > >
> > > _______________________________________________
> > > manet mailing list
> > > [email-masked]
> > > https://www1.ietf.org/mailman/listinfo/manet
> > --
> >     Lawrence MacIntyre     865.574.8696     [email-masked]
> >                Oak Ridge National Laboratory
> > High Performance Information Infrastructure Technology Group
-- 
    Lawrence MacIntyre     865.574.8696     [email-masked]
               Oak Ridge National Laboratory
High Performance Information Infrastructure Technology Group

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 08 Oct 2003 18:06:24 +0200

Lawrence MacIntyre wrote:
> The routing protocol is designed to discover and utilize 
> connectivity.  To communicate with a node, you must have a way to 
> learn its address, but that is not part of the routing protocol.

I agree with that.

I agree there is no way for two manet islands completely unknown to each
other, each one having its own addressing scheme and deployed addresses,
to sort of "join" one another and for their routing tables to get
updated accordingly.

I mean, assume a manet1 made of two nodes with addresses m11 and m12
respectively, and another manet2 made of other two nodes m21 and m22.
When the two manets are separated, communication is ok between m11 and
m12, and between m21 and m22.  Join them by drawing a link between m11
and m21.  After the "join" phase, I don't think there is any manet
technique/protocol that would allow m22 and m11 communicate directly.

What happens if, by lack of chance, nodes in the two manet islands were
initially assigned the same addresses (pairwise: m11 equals m21 and m12
equals m22, but still m11 different than m12 and m21 diff m22)?
Communication inside manet1 is ok, and inside manet2 is also ok, but not
across.

A way of looking at those two networks is to consider that one of them
has many available addresses.  Distributes some of them to its own
nodes by simple DHCP, and keeps a subset of addresses for distribution
(by DHCP prefix delegation) to the other network that "visits" it.  In
this way address conflicts are avoided.  The way the NEMO WG group looks
at this (if I interpret it correctly) is that the DHCP prefix delegation
can happen in this way only if infrastructure is not available (if
available then DHCP prefix delegation happens between the home network
and the moving network, not between the moving network and the fixed
access system).

I think this way of supporting two moving networks in two different
vehicles that need to "join" (while infrastructure is not available) is
viable.

And, because the discussion was triggered with a vehicular background in
mind, there are many potential scenarios related the way this is
deployed, and what's the business need for it.  If a manufacturer wants
its cars to be able to talk to each other such as to automatically avoid
collisions while in a bumper-to-bumper traffic jam, then it would assign
unique addresses to all its vehicles, and a same unique manet protocol
on all vehicles, then two cars of same model could easily talk to each
other w/o infrastructure present.

If on the other hand, manufacturer has a need to remotely update
software deployed in a car, or garage remotely measures mileage and
calls driver for periodic checkup, then this requires communication over
the Internet, with the help of fixed infrastructure, so manet protocols
are not needed at all (but Mobile IP for moving networks yes).

Or again, if a fixed camera measures speed of bypassing vehicles and
notifies driver about crossing limits and fines to pay, in a live
manner, then again, infrastructure is needed, Mobile IP yes, and manet no.

IMHO choosing between manet protocols and Mobile IP-based solution
depends largely on the vehicular scenario involved; what's your scenario
Wanrong?

Alex
GBU

---

From: "Charles E. Perkins" <[email-masked]>
Date: Wed, 08 Oct 2003 10:15:21 -0700

Hello Alexandru,

Alexandru Petrescu wrote:

>    ...  there is no way for two manet islands completely unknown to each

I don't agree with this assessment.

The scenario that you paint in a latter paragraph in your note
has to do with duplicate address assignment.

I agree that when there are duplicate addresses, things are
troublesome, and there is the potential for failure.  But:

1) Given existing constraints on the size of ad hoc networks,
   this should be a rare event in IPv4

2) For IPv6, it should be _extremely_ rare

3) In the absence of rare events, things work pretty well

4) There are ways around the problem if one can nominate an
   address arbitration entity or regime of operation

What this means is that when two ad hoc networks join, there
is the potential for trouble.  But this has to be viewed
with a reasonable tolerance for reality:

- it's practically impossible to prevent in an absolute sense

- there are other dangers, also impossible to prevent, that
  we don't even consider trying to prevent by protocol (e.g.,
  nuclear strike, election of a spider mite for president of USA,
  collisions with asteroids, and currently not even malicious
  node operation).

Whatever solution you may try to devise, please keep the
following examples in mind:

1. Joining of two networks with 500 nodes each
2. Joining of two networks with 20 nodes each
3. Joining of two networks, one with 500 nodes,
   one with 20 nodes
4. Joining of two networks, one with 500 nodes,
   the other with 1 node
5. Joining of two networks, one with 20 nodes,
   the other with 1 node.
6. Joining of two networks, one with 1 node,
   the other with 1 node.

If your solution requires, for the fourth example,
that all 500 nodes start blasting away on some
validation broadcast just because one more node
joins their network, then I claim your solution
is broken.  I would also like to avoid mandating
the existence of an address arbitration authority
in every ad hoc network.  That would be overkill.

I can make one suggestion that hasn't been
discussed very much.  Perhaps we should assign
a lifetime to all autoconfigured addresses in
an ad hoc network.  That way, it is less likely
that two nodes would have the same address for any
extended period of time.  Of course, the lifetime
requires periodic revalidation, not necessarily
relinquishing an address that is currently
configured, as long as the revalidation does
not fail.

Regards,
Charlie P.

PS. I am not on the [nemo] mailing list, so this
    may fail to appear there.

---

From: "HyunWook Cha" <[email-masked]>
Date: Fri, 10 Oct 2003 09:26:41 +0900

Hi, Alex,

In your previous NEMO post, you mean that an NEMO solution using prefix
delegation through DHCP is enough to support this issue or scenario.
But, I think this kind of solution is useful under infrastructured
condition or very short time session. 
If one mobile network is visiting other mobile network attached to wired
Internet, prefix delegation approach has benefit that it can reduce one
level tunneling between a MN in visiting node and its CN.
However, let's consider what happens if no access points(routers) are
available and three mobile networks(cars) are connected temporarily as
following.
    A<-B<-C ( a <- b means a is parent of b or b visiting a)
A delegates a prefix (a:b) to B. B delegates a prefix (b:c) to C.
In this case, if a node with prefix a in A want to communicate a node
with prefix (b:c) in C, how can it be possible without any routing
protocol including MANET? 

Next, what happens if above topology is changed into following one while
a node called 'a'  in A is communicating with a node 'b' with prefix a:b
in B?
    A<-C<-B
In this case, C delegates prefix c:b for B, but it does not help since
network A does not provide HA for delegated prefix (a:b) 
and moreover, mobile router of A can not know route information for
prefix (c:b) without support of routing protocols including MANET.
>From MANET proint of view, this scenario is only usual one and can be
solved in very natural manner. 
If you points to duplicate address problem, several solutions including
"weak DAD" can be helpful.
I think that for mobile networks, these schemes can be applicable for
resolving duplicate prefix problem.

What do you think of this?

Regards,

HyunWook Cha

> From: [email-masked] [mailto:[email-masked]] On 
> Behalf Of Alexandru Petrescu
> Sent: Thursday, October 09, 2003 1:06 AM
> To: Lawrence MacIntyre
> Cc: Pascal Thubert (pthubert); Lawrence MacIntyre; Wanrong 
> Yu; [email-masked]; [email-masked]
> Subject: Re: [nemo] Re: [manet] NEMO or MANET?
> 
> 
> 
> I agree there is no way for two manet islands completely 
> unknown to each other, each one having its own addressing 
> scheme and deployed addresses, to sort of "join" one another 
> and for their routing tables to get updated accordingly.
> 
> I mean, assume a manet1 made of two nodes with addresses m11 
> and m12 respectively, and another manet2 made of other two 
> nodes m21 and m22. When the two manets are separated, 
> communication is ok between m11 and m12, and between m21 and 
> m22.  Join them by drawing a link between m11 and m21.  After 
> the "join" phase, I don't think there is any manet 
> What happens if, by lack of chance, nodes in the two manet 
> islands were initially assigned the same addresses (pairwise: 
> m11 equals m21 and m12 equals m22, but still m11 different 
> than m12 and m21 diff m22)? Communication inside manet1 is 
> ok, and inside manet2 is also ok, but not across.
> 
> A way of looking at those two networks is to consider that 
> one of them has many available addresses.  Distributes some 
> of them to its own nodes by simple DHCP, and keeps a subset 
> of addresses for distribution (by DHCP prefix delegation) to 
> the other network that "visits" it.  In this way address 
> conflicts are avoided.  The way the NEMO WG group looks at 
> this (if I interpret it correctly) is that the DHCP prefix 
> delegation can happen in this way only if infrastructure is 
> not available (if available then DHCP prefix delegation 
> happens between the home network and the moving network, not 
> between the moving network and the fixed access system).
> 
> I think this way of supporting two moving networks in two 
> different vehicles that need to "join" (while infrastructure 
> is not available) is viable.
> 
> And, because the discussion was triggered with a vehicular 
> background in mind, there are many potential scenarios 
> related the way this is deployed, and what's the business 
> need for it.  If a manufacturer wants its cars to be able to 
> talk to each other such as to automatically avoid collisions 
> while in a bumper-to-bumper traffic jam, then it would assign 
> unique addresses to all its vehicles, and a same unique manet 
> protocol on all vehicles, then two cars of same model could 
> easily talk to each other w/o infrastructure present.
> 
> If on the other hand, manufacturer has a need to remotely 
> update software deployed in a car, or garage remotely 
> measures mileage and calls driver for periodic checkup, then 
> this requires communication over the Internet, with the help 
> of fixed infrastructure, so manet protocols are not needed at 
> all (but Mobile IP for moving networks yes).
> 
> Or again, if a fixed camera measures speed of bypassing 
> vehicles and notifies driver about crossing limits and fines 
> to pay, in a live manner, then again, infrastructure is 
> needed, Mobile IP yes, and manet no.
> 
> IMHO choosing between manet protocols and Mobile IP-based 
> solution depends largely on the vehicular scenario involved; 
> what's your scenario Wanrong?
> 
> Alex
> GBU
>

---

From: Alexandru Petrescu <[email-masked]>
Date: Mon, 13 Oct 2003 12:41:26 +0200

HyunWook Cha wrote:
> ...NEMO solution using prefix delegation through DHCP is enough to 
> support this issue or scenario. But, I think this kind of solution is
>  useful under infrastructured condition or very short time session.

Yes, if infrastructure is available and only short time communication is
needed, using DHCP prefix delegation to nodes in the mobile network can
help.  But of course providing reachability at a permanent home address
is not feasible if _only_ prefix delegation is used.

> If one mobile network is visiting other mobile network attached to 
> wired Internet, prefix delegation approach has benefit that it can 
> reduce one level tunneling between a MN in visiting node and its CN.

Richtig.

>  available and three mobile networks(cars) are connected temporarily 
> as following. A<-B<-C ( a <- b means a is parent of b or b visiting 
> a) A delegates a prefix (a:b) to B. B delegates a prefix (b:c) to C. 

A delegates a prefix to B implies that both A and B add entries in their
respective routing tables in order to make forwarding work.  Similar
when B delegates to C.  In this way routes are added where needed, and
without a routing protocol involved.  Moreover, DHCP also distributes
defaults routes to be installed in routing tables.

> Next, what happens if above topology is changed into following one 
> while a node called 'a'  in A is communicating with a node 'b' with 
> prefix a:b in B? A<-C<-B

Ok.  If the topology changes from A-B-C to A-C-B then indeed this is no
longer as static as might have been wished for by NEMO.  This is
definitely something to be dealt with by manet protocols.

Do you have an analytical (if practical even better) example of
behaviour of a manet routing protocol when topology changes from A-B-C
to A-C-B?

> If you points to duplicate address problem, several solutions 
> including "weak DAD" can be helpful. I think that for mobile 
> networks, these schemes can be applicable for resolving duplicate 
> prefix problem.

I was not pointing to a duplicate address assignment problem, mainly
because that equates to other cataclysms that might happen.  I was
pointing to the fact that using manet exclusively does not provide
universal reachability at a permanent home address when the nodes move
anywhere at the edges of the Internet.

Alex
GBU

---

From: Wanrong Yu <[email-masked]>
Date: Mon, 13 Oct 2003 22:16:28 +0800 (HKT)

Hi,Alex
  Sorry for reply so later;-)
>> From the aspect of NEMO, we can loose the restrict 
of the existence 
>> of fixed infrastructure,

>Ok, for the purpose of obtaining what?

>depends largely on the vehicular scenario involved; 
what's your scenario

I mean this is a possible scenario and we should be 
able to deal with the unavailable of fixed 
infrastructure no matter what's the reason for its 
unavailable.

I am a postgraduate student and just "think out" this 
problem when reading NEMO and MANET drafts. I just want 
to know weather this is a deserved research topic. I 
will do more work on this and will submit any results 
to the two WGs.

> definitely something to be dealt with by manet 
protocols.

Agree! This is what I mean, current NEMO WG may not 
focus on this and current MANET protocol "may" be not 
enough to fit this condition.

 Wanrong Yu

---

From: "HyunWook Cha" <[email-masked]>
Date: Tue, 14 Oct 2003 09:56:06 +0900

Hi, Alex.
Thank you for your reply.
Please see inline comments.

> From: Alexandru Petrescu [mailto:[email-masked]] 
> Sent: Monday, October 13, 2003 7:41 PM
> To: [email-masked]
> Subject: Re: NEMO or MANET?
> 
> 
> 
> HyunWook Cha wrote:
> Yes, if infrastructure is available and only short time 
> communication is needed, using DHCP prefix delegation to 
> nodes in the mobile network can help.  But of course 
> providing reachability at a permanent home address is not 
> feasible if _only_ prefix delegation is used.
> 

If infrastructure is not available, I think that delegator in visited
mobile network can not delegate its prefix any more.

> > following. A<-B<-C ( a <- b means a is parent of b or b visiting
> A delegates a prefix to B implies that both A and B add 
> entries in their respective routing tables in order to make 
> forwarding work.  Similar when B delegates to C.  In this way 
> routes are added where needed, and without a routing protocol 
> involved.  Moreover, DHCP also distributes defaults routes to 
> be installed in routing tables.
> 

I understand that new corresponding routing entry is inserted after a
prefix is delegated to visiting mobile network and 
default route entry of visiting network is set to delegator.
But this seems to be insufficient for my question. If sender in A want
to send its packets to destination in C, default route of MR_A should be
set to MR_B.
Can you explain how it works more specifically?

> Do you have an analytical (if practical even better) example 
> of behaviour of a manet routing protocol when topology 
> changes from A-B-C to A-C-B?
> 

As for reactive routing protocol AODV, MR_A altready knows route
information(next_hop : MR_B) for network C through route discovery
before topological change.
After topology changes into A-C-B, MR_A tries to forward
packets(destined to a node in C) of sender in A to MR_B and finds out
link between MR_A and MR_B is broken.
Then, MR_A reinitiates route discovery for C. At this time, MR_C replies
to RREQ of MR_A and MR_A obtains fresh route information for C by
receiving RREP by MR_C.   
As for proactive routing protocol, each MR sends its routing message to
disseminate its reachability info after it finds out that any link to
neighbors change.

> I was not pointing to a duplicate address assignment problem, 
> mainly because that equates to other cataclysms that might 
> happen.  I was pointing to the fact that using manet 
> exclusively does not provide universal reachability at a 
> permanent home address when the nodes move anywhere at the 
> edges of the Internet.

I agree. MIP, NEMO are tackling this subject.
I think manet routing protocols are useful for inter mobile network
routing when networks are nested whether they are attached to Internet
or not.
In addition, they can be used for RO in netsted mobile network using
manet internet gateway.

Regards,
HyunWook Cha

---

From: Christophe Jelger <[email-masked]>
Date: Thu, 16 Oct 2003 15:02:04 +0200

Hi all,

I agree with Charlie Perkins, i.e. a short lifetime should be assigned 
to addresses being autoconfigured. The main reason is that (I believe) 
an inherent feature of an address autoconfiguration protocol must be its 
reactiveness to topological changes. The only way of doing this is to 
periodically refresh the address assignment, whatever method is used to 
perform it.

Therefore if the address is refreshed frequently (say, every 2s), there 
is no need for the address lifetime to be much longer than 2s. In any 
case, if an address is not refreshed in time, it probably means there is 
a problem (e.g. network partitioning) and the address should therefore 
no be used any longer --> with a short lifetime, the adress would be 
removed automatically by the host OS.

Regards,
Christophe Jelger